import java.net.*;
import java.util.regex.Pattern;
import java.io.*;

public class CallClient {
	private static boolean firstCall = true;


	public static final String ENV_SOCKET = "eclipsecall.socket";
	public static final String ENV_CALL = "eclipsecall.call";

	private static final Pattern p_arg = Pattern.compile("\\-[SG][0-9,\\-]+");
	public static void main(String[] args) {
		Socket server = null;
		String eclipse = null;
		String call = "";
		int sockno = 2341;

		try {
			String env_sock = System.getProperty(ENV_SOCKET);
			String env_call = System.getProperty(ENV_CALL);
			if (env_call != null) {
				eclipse = env_call;
			}
			if (env_sock != null) {
				sockno = Integer.parseInt(env_sock);
			}
		}
		catch (Throwable T) {
			// nothing to do
		}

		try {
			if (args.length == 0) {
				System.out.println("usage: ");
				System.out
						.println("eclipsecall <filename> [-G<lineno>[,<col>-<col>]] [-S<socketno>] [-E<eclipse.exe>]");
				System.out.println("example:");
				System.out.println("mark column 10-20 in line 100 of myfile: ");
				System.out.println("> eclipsecall D:\\mydir\\myfile -G100,10-20");
				System.out.println("only show myfile without marking: ");
				System.out.println("> eclipsecall D:\\mydir\\myfile");
				System.exit(-1);
			}
			int i = 0;
			call = args[0];
			while (i < args.length-1 && !args[i+1].startsWith("-")) {
				call += " " + args[i+1];
				i++;
			}
			i++;
			for (; i < args.length; i++) {
				if (args[i].startsWith("-G")) {
					String add = args[i].substring(2);
					add = add.replace(',', '|');
					call += "|" + add;
				} else if (args[i].startsWith("-S")) {
					sockno = Integer.parseInt(args[i].substring(2));
				} else if (args[i].startsWith("-E")) {
					eclipse = args[i].substring(2);
					while (i < args.length-1) {
						if (p_arg.matcher(args[i+1]).matches()) {
							break;
						}
						eclipse += " ";
						String add = args[i+1];
						if (args[i+1].contains(" ") || args[i+1].contains("(")) {
							add = "\"" + add + "\"";
						}
						eclipse += " " + add;
						i++;
					}
				}
			}

			// try to establish the socket connection
			server = new Socket("localhost", sockno);
			OutputStream out = server.getOutputStream();
			out.write(call.getBytes());
			out.flush();
			server.close();
		} catch (ConnectException ex) {
			// on connection exception: try to start the program given by the "-E" parameter
			if (firstCall) {
				firstCall = false;
				if (eclipse != null) {
					try {
						Runtime.getRuntime().exec(eclipse);
						synchronized (CallClient.class) {
							CallClient.class.wait(3000);
						}
						for (int i = 0; i < 120; i++) {
							try {
								server = new Socket("localhost", sockno);
								synchronized (CallClient.class) {
									CallClient.class.wait(1000);
								}
								server.close();
								server = new Socket("localhost", sockno);
								OutputStream out = server.getOutputStream();
								out.write(call.getBytes());
								out.flush();
								server.close();
								new Thread(new Runnable() {
									public void run() {
										synchronized (CallClient.class) {
											try {
												CallClient.class.wait(200);
											}
											catch (Throwable T) {
												// nothing to do
											}
										}
										System.exit(0);
									}
								}).start();
							}
							catch (ConnectException e) {
								// nothing to do - wait a little longer
							}
							synchronized (CallClient.class) {
								CallClient.class.wait(500);
							}
						}
					} catch (Exception e) {
						e.printStackTrace();
					}
				}
			}
		} catch (UnknownHostException e) {
			e.printStackTrace();
		} catch (IOException e) {
			e.printStackTrace();
		} finally {
			if (server != null)
				try {
					server.close();
				} catch (IOException e) {
					e.printStackTrace();
				}
		}
	}
}
